/* FlatServe.java
 *
 * created: Tue May 11 1999
 *
 * This file is part of Artemis
 *
 * Copyright (C) 1999  Genome Research Limited
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Header: /nfs/disk222/yeastpub/Repository/flatimpl/FlatServe.java,v 1.5.2.4 2000/09/20 14:28:32 kmr Exp $
 */

import org.omg.CORBA.*;

import uk.ac.sanger.pathogens.*;
import uk.ac.sanger.pathogens.embl.*;

import java.io.*;
import java.util.Properties;

/**
 *  FlatServe class
 *
 *  @author Kim Rutherford
 *  @version $Id: FlatServe.java,v 1.5.2.4 2000/09/20 14:28:32 kmr Exp $
 **/

public class FlatServe {
  /**
   *
   **/
  public static void main (final String [] args) {
    try {
      ORB orb = ORB.init (args, new java.util.Properties());
      BOA boa = orb.BOA_init (args, new java.util.Properties());

      if (args.length > 0 && args[0].equals ("-write")) {
        final EmblWriterImpl embl = new EmblWriterImpl ();

        final String ior_file_name;

        if (args.length > 1) {
          ior_file_name = args[1];
        } else {
          ior_file_name = "write_server_ior_file";
        }

        final Writer writer = new FileWriter (ior_file_name);
        final PrintWriter print_writer = new PrintWriter (writer);
        System.err.println ("starting write server");
        print_writer.println (orb.object_to_string (embl));
        print_writer.close ();
        writer.close ();
        System.err.println ("wrote IOR to " + ior_file_name);
      } else {
        final EmblImpl embl = new EmblImpl ();
        final String ior_file_name;

        if (args.length > 1) {
          ior_file_name = args[1];
        } else {
          ior_file_name = "ro_server_ior_file";
        }

        final Writer writer = new FileWriter (ior_file_name);
        final PrintWriter print_writer = new PrintWriter (writer);
        System.err.println ("starting server");
        print_writer.println (orb.object_to_string (embl));
        print_writer.close ();
        writer.close ();
        System.err.println ("wrote IOR to " + ior_file_name);
      }

      // Wait for incoming requests
      boa.impl_is_ready (null);

      Thread.currentThread ().join ();
    } catch (Exception e) {
      System.err.println (e);
    }
  }
}

