// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/EntryInfo:1.0
//
/**
 * The EMBL database contains information, which is not really part of the
 * sequence information. This information is stored in the EntryInfo.
 **/
public interface EntryInfo extends org.omg.CORBA.Object
{

    //
    // IDL:nsdb/EntryInfo/getEntryName:1.0
    //
    /**
     * Retrieve entry indentifier. More information on the 
     * <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/usrman/id_line.html">format</A> of
     * an entry name is available in the
     *  <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/usrman/usrman.html">
     * EMBL User Manual</A>.
     **/
    public String
    getEntryName();

    //
    // IDL:nsdb/EntryInfo/getEntryVersion:1.0
    //
    /**
     * The entry version defines the current version of an EMBL Sequence Database
     * Entry. I.e. the complete set information related to a particular sequence.
     * The Entry version is incremented whenever anything changes in the sequence or it's 
     * associated information.
     **/
    public int
    getEntryVersion();

    //
    // IDL:nsdb/EntryInfo/getEntryStatus:1.0
    //
    /**
     * Get entry status code.
     * @see meta::nsdb
     **/
    public String
    getEntryStatus();

    //
    // IDL:nsdb/EntryInfo/getRevisions:1.0
    //
    /**
     * Sequence of revisions when Entry was created/changed.
     **/
    public type.Revision[]
    getRevisions();

    //
    // IDL:nsdb/EntryInfo/getSecondaryIds:1.0
    //
    /**
     * List of secondary accession numbers. I.e. accession numbers
     * of deprecated entries, now merged into the current entry or
     * split over multiple entries, as decribed in the 
     * <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/usrman/ac_line.html">
     * AC line</A> documentation in the User manual.
     **/
    public String[]
    getSecondaryIds();

    //
    // IDL:nsdb/EntryInfo/getCountA:1.0
    //
    /**
     * number of adenine
     **/
    public int
    getCountA();

    //
    // IDL:nsdb/EntryInfo/getCountC:1.0
    //
    /**
     * number of cytosine
     **/
    public int
    getCountC();

    //
    // IDL:nsdb/EntryInfo/getCountG:1.0
    //
    /**
     * number of guanine 
     **/
    public int
    getCountG();

    //
    // IDL:nsdb/EntryInfo/getCountT:1.0
    //
    /**
     * number of thymine (in DNA sequence)
     *    or
     * number of uracil (in RNA sequence)
     **/
    public int
    getCountT();
}
