// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/NucFeature:1.0
//
/**
 * Nucleotide Sequence Feature interface. Features are <I>owned</I> by a
 * sequence and contain information about that (and maybe other) sequence.
 * The relation between the feature and the sequence is defined by it's
 * location.
 * @see Location
 **/
public interface NucFeature extends seqdb.Feature
{

    //
    // IDL:nsdb/NucFeature/string_qtc:1.0
    //
    public static final int string_qtc = (int)(1L);

    //
    // IDL:nsdb/NucFeature/boolean_qtc:1.0
    //
    public static final int boolean_qtc = (int)(2L);

    //
    // IDL:nsdb/NucFeature/integer_qtc:1.0
    //
    public static final int integer_qtc = (int)(3L);

    //
    // IDL:nsdb/NucFeature/real_qtc:1.0
    //
    public static final int real_qtc = (int)(4L);

    //
    // IDL:nsdb/NucFeature/TranslationException_qtc:1.0
    //
    public static final int TranslationException_qtc = (int)(17L);

    //
    // IDL:nsdb/NucFeature/CodonTranslation_qtc:1.0
    //
    public static final int CodonTranslation_qtc = (int)(18L);

    //
    // IDL:nsdb/NucFeature/Anticodon_qtc:1.0
    //
    public static final int Anticodon_qtc = (int)(19L);

    //
    // IDL:nsdb/NucFeature/SpliceConsensus_qtc:1.0
    //
    public static final int SpliceConsensus_qtc = (int)(20L);

    //
    // IDL:nsdb/NucFeature/RepeatUnit_qtc:1.0
    //
    public static final int RepeatUnit_qtc = (int)(21L);

    //
    // IDL:nsdb/NucFeature/DbXref_qtc:1.0
    //
    public static final int DbXref_qtc = (int)(22L);

    //
    // IDL:nsdb/NucFeature/getQualifiers:1.0
    //
    /**
     * Retrieve sequence of qualifiers.
     * @raises type::NoResult if no qualifiers are associated with
     *    the feature.
     **/
    public nsdb.NucFeaturePackage.Qualifier[]
    getQualifiers()
        throws type.NoResult;

    //
    // IDL:nsdb/NucFeature/getQualifier:1.0
    //
    /**
     * retrieve qualifier of a certain type.
     * To find out which qualifier/feature combinations are valid, a client should
     * query the NucFeatureMeta server.
     * @raises type::NoResult if no qualifier of this type is associated with
     *   the feature
     * @raises type::InvalidRelation if the requested qualifier cannot be
     *   associated to the current feature type
     * @see metafeature::NucFeatureMeta
     **/
    public nsdb.NucFeaturePackage.Qualifier
    getQualifier(String qualifier_name)
        throws type.NoResult,
               type.InvalidRelation;

    //
    // IDL:nsdb/NucFeature/getNucSeqs:1.0
    //
    /**
     * If the location of the feature references multiple sequences, get a 
     * sequence of all sequences referenced
     * This method is equivalent to retrieving the feature location, and looping
     *  through all location nodes to find the referenced sequences, converting 
     * the accession numbers into DbXref's.
     **/
    public type.DbXref[]
    getNucSeqs();

    //
    // IDL:nsdb/NucFeature/getLocation:1.0
    //
    /**
     * retrieve location of feature.
     * @raises type::NoResult if no location is associated with the feature.
     **/
    public FeatureLocation
    getLocation()
        throws type.NoResult;
}
