// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.1
// License: non-commercial

package nsdb;

//
// IDL:nsdb/NucSeq:1.0
//
public abstract class _NucSeqImplBase extends org.omg.CORBA.DynamicImplementation
                                      implements NucSeq
{

    //
    // IDL:nsdb/NucSeq/getSeq:1.0
    //
    /**
     * retrieve string representation of nucleotide sequence. Each character
     * in the string is a 
     *   <href="http://www.ebi.ac.uk/ebi_docs/embl_db/ft/iupac_codes.html">
     *   IUPAC nucleotide base code</A>
     * <P>
     * This method can be used instead of the getAnySeq() 
     * method in seqdb::BioSeq
     * @see seqdb::BioSeq
     **/
    final private void
    _OB_op_getSeq(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        String _ob_r = getSeq();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_string(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:nsdb/NucSeq/getCheckSum:1.0
    //
    /**
     * Checksum on sequence to allow validation.
     * 
     **/
    final private void
    _OB_op_getCheckSum(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        int _ob_r = getCheckSum();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_ulong(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:nsdb/NucSeq/getTopology:1.0
    //
    /**
     * topology of the nucleotide sequence
     * @see meta::nsdb
     **/
    final private void
    _OB_op_getTopology(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        String _ob_r = getTopology();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_string(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:nsdb/NucSeq/getMoleculeType:1.0
    //
    /**
     * molecule type of the nucleotide sequence
     * @see meta::nsdb
     **/
    final private void
    _OB_op_getMoleculeType(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        String _ob_r = getMoleculeType();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_string(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:nsdb/NucSeq/getNucFeatures:1.0
    //
    /**
     * retrieve sequence of NucFeatureList associated with
     * the nucleotide sequence.
     * A sequence has <I>ownership</I> of all these 
     * features. It is possible on the other hand that
     * features, owned by another sequence, reference 
     * the current sequence. Currently there is no way to find out.
     * @raises type::NoResult if no features are owned by the sequence
     **/
    final private void
    _OB_op_getNucFeatures(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        try
        {
            nsdb.NucFeature[] _ob_r = getNucFeatures();

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            nsdb.NucFeatureListHelper.insert(_ob_ra, _ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.NoResult _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.NoResultHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getLocalLocation:1.0
    //
    /**
     * A location of a NucFeature can span multiple sequences.
     * If only the location of a feature relevant to the current
     * sequence is required, this method will calculate that.
     * @parm nuc_feature Feature from which location needs to be
     *   intersected with the current sequence.
     * @raises type::InvalidRelation if the nuc_feature 
     *   is not associated to the current sequence
     **/
    final private void
    _OB_op_getLocalLocation(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        org.omg.CORBA.Any _ob_aa0 = _orb().create_any();
        _ob_aa0.type(nsdb.NucFeatureHelper.type());
        _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
        _ob_req.params(_ob_list);

        nsdb.NucFeature _ob_a0 = nsdb.NucFeatureHelper.extract(_ob_aa0);

        try
        {
            nsdb.Location _ob_r = getLocalLocation(_ob_a0);

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            nsdb.LocationHelper.insert(_ob_ra, _ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.InvalidRelation _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.InvalidRelationHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getOrganisms:1.0
    //
    /**
     * organism(s) from which the NucSeq was obtained.
     * If the sequence is chimeric, multiple organisms will be returned.
     * For each organism, there should be a source feature associated
     * with the current sequence. This source feature has a location
     * defining which part of the sequence was derived from the specified
     * organism.
     * This method provides a shortcut to:
     * invoke getNucFeaturesByKey("source"), invoke getQualifiers() on each 
     * source feature and loop through qualifiers to find DbXref. 
     * @raises type::NoResult if no source features are associated with
     * the sequence (should never happen).
     **/
    final private void
    _OB_op_getOrganisms(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        try
        {
            type.DbXref[] _ob_r = getOrganisms();

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            type.DbXrefListHelper.insert(_ob_ra, _ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.NoResult _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.NoResultHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getNucFeaturesByKey:1.0
    //
    /**
     * retreive all features of a specific kind (FeatureKey)
     * @parm key Type of features to be retrieved
     * @raises type::NoResult if the sequence has no associated features
     *     of the requested type.
     * @raises type::InvalidArgumentValue if the key is not a 
     * <A href="http://www.ebi.ac.uk/ebi_docs/embl_db/ft/feature_table.html">
     * valid feature key</A>
     * @see NucFeature
     **/
    final private void
    _OB_op_getNucFeaturesByKey(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        org.omg.CORBA.Any _ob_aa0 = _orb().create_any();
        _ob_aa0.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
        _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
        _ob_req.params(_ob_list);

        String _ob_a0 = _ob_aa0.extract_string();

        try
        {
            nsdb.NucFeature[] _ob_r = getNucFeaturesByKey(_ob_a0);

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            nsdb.NucFeatureListHelper.insert(_ob_ra, _ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.NoResult _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.NoResultHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
        catch(type.InvalidArgumentValue _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.InvalidArgumentValueHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getSubSeq:1.0
    //
    /**
     * Create nucleotide sequence of the segment specified
     * The first base in the sequence is numbered 1
     *
     * @parm start first base of sub-sequence (inclusive)
     * @parm end last base of sub-sequence (inclusive)
     * @raises type::IndexOutOfRange if start &lt 1
     *   or end &gt length
     **/
    final private void
    _OB_op_getSubSeq(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        org.omg.CORBA.Any _ob_aa0 = _orb().create_any();
        _ob_aa0.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong));
        _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
        org.omg.CORBA.Any _ob_aa1 = _orb().create_any();
        _ob_aa1.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong));
        _ob_list.add_value("", _ob_aa1, org.omg.CORBA.ARG_IN.value);
        _ob_req.params(_ob_list);

        int _ob_a0 = _ob_aa0.extract_ulong();
        int _ob_a1 = _ob_aa1.extract_ulong();

        try
        {
            String _ob_r = getSubSeq(_ob_a0, _ob_a1);

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            _ob_ra.insert_string(_ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.IndexOutOfRange _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.IndexOutOfRangeHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getSubSeqByFeature:1.0
    //
    /** 
     * Create nucleotide sequence of the location derived from the specified feature
     * and contained in the current NucSeq.
     * @raises type::InvalidRelation if the nuc_feature 
     *   is not associated to the current sequence
     * @raises InexactLocation if an exact sequence cannot be
     *   determined due to the feature's location being inexact
     **/
    final private void
    _OB_op_getSubSeqByFeature(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        org.omg.CORBA.Any _ob_aa0 = _orb().create_any();
        _ob_aa0.type(nsdb.NucFeatureHelper.type());
        _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
        _ob_req.params(_ob_list);

        nsdb.NucFeature _ob_a0 = nsdb.NucFeatureHelper.extract(_ob_aa0);

        try
        {
            String _ob_r = getSubSeqByFeature(_ob_a0);

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            _ob_ra.insert_string(_ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.InvalidRelation _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.InvalidRelationHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
        catch(nsdb.InexactLocation _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            nsdb.InexactLocationHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:nsdb/NucSeq/getReferenceLocation:1.0
    //
    /**
     * @raises type::InvalidRelation if reference does not exist
     * @raises type::InvalidRelation if reference is not 
     *   associated to the current sequence
     * @raises type::NoResult if there is no location associated with this reference
     **/
    final private void
    _OB_op_getReferenceLocation(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        org.omg.CORBA.Any _ob_aa0 = _orb().create_any();
        _ob_aa0.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
        _ob_list.add_value("", _ob_aa0, org.omg.CORBA.ARG_IN.value);
        _ob_req.params(_ob_list);

        String _ob_a0 = _ob_aa0.extract_string();

        try
        {
            nsdb.Location _ob_r = getReferenceLocation(_ob_a0);

            org.omg.CORBA.Any _ob_ra = _orb().create_any();
            nsdb.LocationHelper.insert(_ob_ra, _ob_r);
            _ob_req.result(_ob_ra);
        }
        catch(type.InvalidRelation _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.InvalidRelationHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
        catch(type.NoResult _ob_ex)
        {
            org.omg.CORBA.Any _ob_exa = _orb().create_any();
            type.NoResultHelper.insert(_ob_exa, _ob_ex);
            _ob_req.except(_ob_exa);
        }
    }

    //
    // IDL:seqdb/BioSeq/getBioSeqId:1.0
    //
    /**
     * retrieve unique identifier
     **/
    final private void
    _OB_op_getBioSeqId(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        String _ob_r = getBioSeqId();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_string(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:seqdb/BioSeq/getLength:1.0
    //
    /**
     * length (nr of elements) of the biosequence
     **/
    final private void
    _OB_op_getLength(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        int _ob_r = getLength();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_ulong(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:seqdb/BioSeq/getAnySeq:1.0
    //
    /**
     * sequence of objects describing the elements in the biosequence
     * This is a generic description. Most subclasses
     * will define more convenient methods for accessing the biosequence.
     * @returns any containing an set of objects. The any should have 
     *          a typecode tk_array.
     **/
    final private void
    _OB_op_getAnySeq(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        org.omg.CORBA.Any _ob_r = getAnySeq();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_any(_ob_r);
        _ob_req.result(_ob_ra);
    }

    //
    // IDL:seqdb/BioSeq/getBioSeqVersion:1.0
    //
    /**
     * Return current version of the BioSeq. returns 0 if versioning is not
     * implemented on the bioseq.
     **/
    final private void
    _OB_op_getBioSeqVersion(org.omg.CORBA.ServerRequest _ob_req)
    {
        org.omg.CORBA.NVList _ob_list = _orb().create_list(0);
        _ob_req.params(_ob_list);

        int _ob_r = getBioSeqVersion();

        org.omg.CORBA.Any _ob_ra = _orb().create_any();
        _ob_ra.insert_ulong(_ob_r);
        _ob_req.result(_ob_ra);
    }
    static final String[] _ob_ids_ =
    {
        "IDL:nsdb/NucSeq:1.0",
        "IDL:seqdb/BioSeq:1.0"
    };

    public String[]
    _ids()
    {
        return _ob_ids_;
    }

    final public void
    invoke(org.omg.CORBA.ServerRequest _ob_req)
    {
        String _ob_op = _ob_req.op_name();
        final String[] _ob_names =
        {
            "getAnySeq",
            "getBioSeqId",
            "getBioSeqVersion",
            "getCheckSum",
            "getLength",
            "getLocalLocation",
            "getMoleculeType",
            "getNucFeatures",
            "getNucFeaturesByKey",
            "getOrganisms",
            "getReferenceLocation",
            "getSeq",
            "getSubSeq",
            "getSubSeqByFeature",
            "getTopology"
        };

        int _ob_left = 0;
        int _ob_right = _ob_names.length;
        int _ob_m;
        int _ob_index = -1;

        while(_ob_left < _ob_right)
        {
            _ob_m = (_ob_left + _ob_right) / 2;
            int _ob_res = _ob_names[_ob_m].compareTo(_ob_op);
            if(_ob_res == 0)
            {
                _ob_index = _ob_m;
                break;
            }
            if(_ob_res > 0)
                _ob_right = _ob_m;
            else
                _ob_left = _ob_m + 1;
        }

        switch(_ob_index)
        {
        case 0: // getAnySeq
            _OB_op_getAnySeq(_ob_req);
            return;

        case 1: // getBioSeqId
            _OB_op_getBioSeqId(_ob_req);
            return;

        case 2: // getBioSeqVersion
            _OB_op_getBioSeqVersion(_ob_req);
            return;

        case 3: // getCheckSum
            _OB_op_getCheckSum(_ob_req);
            return;

        case 4: // getLength
            _OB_op_getLength(_ob_req);
            return;

        case 5: // getLocalLocation
            _OB_op_getLocalLocation(_ob_req);
            return;

        case 6: // getMoleculeType
            _OB_op_getMoleculeType(_ob_req);
            return;

        case 7: // getNucFeatures
            _OB_op_getNucFeatures(_ob_req);
            return;

        case 8: // getNucFeaturesByKey
            _OB_op_getNucFeaturesByKey(_ob_req);
            return;

        case 9: // getOrganisms
            _OB_op_getOrganisms(_ob_req);
            return;

        case 10: // getReferenceLocation
            _OB_op_getReferenceLocation(_ob_req);
            return;

        case 11: // getSeq
            _OB_op_getSeq(_ob_req);
            return;

        case 12: // getSubSeq
            _OB_op_getSubSeq(_ob_req);
            return;

        case 13: // getSubSeqByFeature
            _OB_op_getSubSeqByFeature(_ob_req);
            return;

        case 14: // getTopology
            _OB_op_getTopology(_ob_req);
            return;
        }

        throw new org.omg.CORBA.BAD_OPERATION();
    }
}
